#include <iostream.h>
#include "SCalculator.h"

const char* VERSION = "0.5";

void printWelcomeMsg()
{
	cout << "------------------------------------------------"<< endl 
	     << "            EazyKalc v" << VERSION      << endl << endl
	     << " Programmed by Andre Stein"		 << endl
	     << " Copyright 2002 by SteinSOFT - www.steinsoft.net"		 << endl << endl
	     << " Type 'help' for a detailed help screen"<< endl
	     << "   It is recommened to take a look at " << endl
	     << "   this screen to see the basic funct." << endl
	     << " Type 'exit' to close EazyKalc"	 << endl
	     << "------------------------------------------------"<< endl 
	     << endl;
	
		
}

void printHelpMsg()
{
	cout << endl
	     << "** EazyKalc Help Screen" << endl
	     << "  ex." << endl
	     << "    (5*89)+2^2" << endl
	     << "    |-8*56|/(56^6-789) " << endl
	     << "    var={[67+(5+1)]-89}*pi" << endl
	     << "    var^(-67) " << endl
	     << "   a:b or a/b    divides a through b" << endl
	     << "   a*b           multiplies a by b" << endl
	     << "   a+b, a-b      addition and subtraction" << endl
	     << "   {[(...)]}     parantheses" << endl
	     << "   |expr|        absolute value of 'expr'" << endl << endl
	     << "  Order of operators:" << endl
	     << "    | , () , ^ , * , / , + , - , = " << endl
	     << "  Variables:" << endl
	     << "    Create a new variable with 'var=expr'" << endl
	     << "     -> sets var to expr." << endl
	     << "    This variable can later be used like above." << endl
	     << "  Predefined and user-defined variables: " << endl
	     << "    type 'showvars'     " << endl
	     << "  Functions:" << endl
	     << "    type 'showfuncs'" << endl << endl;
}

void printFunctions()
{
	cout << endl
	     << "** EazyKalc Functions" << endl
	     << "   sin(x), cos(x), tan(x), cot(x)  Standard trigonometric functions" << endl
	     << "   asin(x), acos(x), atan(x)       Arcsin etc. from x" << endl << endl
	     << " The variable 'rad' specifies whether the angles are given in" << endl
	     << " radians or degrees. By default, rad=0 so angles are in degrees." << endl << endl
	     << " Example:" << endl
	     << "   sin(90)*cos(90)" << endl
	     << "   acos(0)" << endl
	     << "   rad=1" << endl
	     << "   sin(pi)" << endl << endl;
}

int main(int argc, char* argv[])
{
	SCalculator calculator;
	SString expression;

	printWelcomeMsg();

//	cout.precision(200);
	/*cout.setf(ios::floatfield,ios::fixed);
	cout.unsetf(ios::showpoint);*/

	for (;;) 
	{
		cout << "> ";
		
		cin >> expression;
		expression.toUpperCase();
		
		if ( expression == "EXIT")
		{
			break;
		}
		else if (expression == "HELP")
		{
			printHelpMsg();

			continue;
		}
		else if (expression == "SHOWVARS")
		{
			calculator.printVars();

			continue;
		}
		else if (expression == "SHOWFUNCS")
		{
			printFunctions();

			continue;
		}

		cout << "= " << calculator.parse(expression) << endl;
	} 
	
	return 0;
}